aboutsummaryrefslogtreecommitdiffstats
path: root/scripts/rstrip.sh
diff options
context:
space:
mode:
authorFelix Fietkau <nbd@openwrt.org>2007-02-09 16:24:34 +0000
committerFelix Fietkau <nbd@openwrt.org>2007-02-09 16:24:34 +0000
commita94d2be696b19383fa65ba53a22c862c73508c2b (patch)
tree1c4a855e5240489593ea09e9b72a5c378b77ae14 /scripts/rstrip.sh
parentc11f1b9ea6a3c0c68665f1f69f55f6408bfe7c3d (diff)
downloadmaster-187ad058-a94d2be696b19383fa65ba53a22c862c73508c2b.tar.gz
master-187ad058-a94d2be696b19383fa65ba53a22c862c73508c2b.tar.bz2
master-187ad058-a94d2be696b19383fa65ba53a22c862c73508c2b.zip
more fixes for rstrip.sh and kernel modules - fixes #1301
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@6280 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'scripts/rstrip.sh')
-rwxr-xr-xscripts/rstrip.sh23
1 files changed, 21 insertions, 2 deletions
diff --git a/scripts/rstrip.sh b/scripts/rstrip.sh
index 252522bfaa..6dd44f2ed2 100755
--- a/scripts/rstrip.sh
+++ b/scripts/rstrip.sh
@@ -6,6 +6,23 @@
# See /LICENSE for more information.
#
+find_modparams() {
+ FILE="$1"
+ $NM "$FILE" | awk '
+BEGIN {
+ FS=" "
+}
+($3 ~ /^__module_parm_/) && ($3 !~ /^__module_parm_desc/) {
+ gsub(/__module_parm_/, "", $3)
+ printf "-K " $3 " "
+}
+($2 ~ /r/) && ($3 ~ /__param_/) {
+ gsub(/__param_/, "", $3)
+ printf "-K " $3 " "
+}
+'
+}
+
SELF=${0##*/}
@@ -28,9 +45,11 @@ find $TARGETS -type f -a -exec file {} \; | \
IFS=":"
while read F S; do
echo "$SELF: $F:$S"
- [ "${F##*\.}" = "o" -o "${F##*\.}" = "ko" ] && \
- eval "$STRIP_KMOD $F" || \
+ [ "${F##*\.}" = "o" -o "${F##*\.}" = "ko" ] && {
+ eval "$STRIP_KMOD -w -K '__param*' -K '__mod*' $(find_modparams "$F")$F"
+ } || {
eval "$STRIP $F"
+ }
done
true
)